#ifndef lint
static const char rcsid[] = 
	"@(#)$Id: rktcl.c,v 1.6 1994/09/22 01:42:01 schwartz Exp $";
#endif

#include <stdlib.h>
#include <tcl.h>
#include "rk.h"

static char* gensym (void) 
{
    static int n = 1;
    static char sym[32];
    sprintf (sym, "rk__.%d", n++);
    return sym;
}

int Tcl_rk_cmd (ClientData cld, Tcl_Interp *ti, int argc, char **argv)
{
    struct rk *rk = (struct rk*)cld;

    if (!rk) {
        sprintf (ti->result, "nil clientdata");
	return TCL_ERROR;
    }

    if ((argc != 2) && (argc != 3) && (argc != 4)) {
	sprintf (ti->result, "usage: %s cmd [arg]", argv[0]);
	return TCL_ERROR;
    }

#define strsame(a,b) (strcmp((a),(b))==0)

    if (strsame (argv[1], "predict")) {
	if (argc != 4) goto arg_count;
	make_a_prediction (rk, atoi (argv[2]), argv[3]);
	Tcl_SetResult (ti, rk->pred_buff, TCL_STATIC);
    } else if (strsame (argv[1], "prime")) {
	if (argc != 3) goto arg_count;
	prime_from_file (rk, argv[2]);
    } else if (strsame (argv[1], "update")) {
	if (argc != 3) goto arg_count;
	update_the_model (rk, argv[2]);
    }
    return TCL_OK;
 arg_count:
    sprintf (ti->result, "wrong # args: %s %s [arg]", argv[0], argv[1]);
    return TCL_ERROR;
}

int Tcl_rk_alloc (ClientData cld, Tcl_Interp *ti, int argc, char **argv)
{
    char* cmd;
    struct rk *rk;

    if (argc != 1) {
        sprintf(ti->result, "wrong # args: should be \"%s\"", argv[0]);
        return TCL_ERROR;
    }
    if ((rk = rk_alloc (malloc)) == 0) {
	sprintf (ti->result, "%s: out of memory", argv[0]);
	return TCL_ERROR;
    }
    init_reactive (rk, 0, 0); /* XXX - let user specify all parameters  */
    cmd = gensym ();
    Tcl_CreateCommand (ti, cmd, Tcl_rk_cmd, (ClientData) rk,
		       (Tcl_CmdDeleteProc *) 0);
    /* XXX - write delproc */
    strcpy (ti->result, cmd);
    return TCL_OK;
}


int Rk_Init (interp)
Tcl_Interp* interp;
{
  Tcl_CreateCommand (interp, "new_rk", Tcl_rk_alloc, (ClientData) 0,
		     (Tcl_CmdDeleteProc *) 0);
  return TCL_OK;
}
